

#include "main.h"

//---------------- init -------------------

uint8_t eeFooByteArray1[80] EEPROM ;


char * tag_set[]={	"Noswich    ",
					"Sonntag    ",
					"Montag     ",
					"Dienstag   ",
					"Mittwoch   ",
					"Donnerstag ",
					"Freitag    ",
					"Samstag    ",
					"Woche      "};

char * stat_set[]={	"Aus",
					"Ein"};



char  send[30];


//---- Schaltzeiten aus EEPROM lesen
void ee_read_SWT(void){eeprom_read_block(wodata,eeFooByteArray1,sizeof(wodata));}	// Block lesen


void ee_write(void){eeprom_write_block(wodata,eeFooByteArray1,sizeof(wodata));}	// Block schreiben



//---------------- String in Integer umwandeln -------
// Start = 1.Position im String 
// Max 	 = lnge des umzuwandelnden Strings
int einlesen(char *data,uint8_t start,uint8_t max){
uint8_t i;											
int	wert;											

char s[max+2];

for(i=start;i<(start+max);i++) s[i-start]= data[i];

s[max+1]='\0';			//String abschliesen
wert= atoi(s);
return wert;
}

//--------- Auentemperatur + Status  + Zeit senden ------------------------
void SendAussen(void){
uint8_t i;

	for(i=0;i<c_max_empf;i++)send[i]=0x20; // Datenbyte auf null setzen

	sprintf( send,"O%4d%3d%2d%2d%2d",Sensor[0],Status.byte,tag,stunde,minute);


	while ( ser.gesperrt ==true ) ;	// warten bis Datenleitung frei ist 
	
	ser.noData=true;	// Daten Empfang aus	

// Datensatz ausgeben
	uputchar(uartstart);



	// leerzeichen mit '0' ersetzen und senden  

	for(i=0;i<c_max_empf;i++){if(send[i]==0x20)send[i]=0x30;uputchar(send[i]);}

	uputchar(uartstopp);

	ser.noData=false;	// Daten Empfang ein
}
 


//------------- Daten Zeit Seriell einlesen ----------------
void ZeitEinlesen(void){		
	
		//Startadresse Data	=4
			
		tag  =einlesen(serData,4,2);		
		stunde=einlesen(serData,6,2);	
		minute=einlesen(serData,8,2);
		Status.byte=einlesen(serData,10,3);		
}


//------------- Status seriell ausgeben ----------------
void statusSenden(void){
uint8_t i;






//	for(i=0;i<c_max_empf;i++)send[i]=0x20; // Datenbyte auf null setzen

// Datensatz erstellen
// komando + Adresse +Wert
	sprintf( send,"s:%3d:%3d:%4d:%4d:%4d:%4d:%4d:%4d:%4d:%4d:",adresse,Status.byte,Sensor[0],Sensor[1],Sensor[2],Sensor[3],
	Sensor[4],Sensor[5],Sensor[6],Sensor[7]);
	
	while ( ser.gesperrt ==true ) ;	// warten bis Datenleitung frei ist 
	
	ser.noData=true;	// Daten Empfang aus	

// Datensatz ausgeben
	uputchar(uartstart);



	// leerzeichen mit '0' ersetzen und senden  50 Zeichen ausgeben

	for(i=0;i<50;i++){if(send[i]==0x20)send[i]=0x30;uputchar(send[i]);}

	uputchar(uartstopp);

	ser.noData=false;	// Daten Empfang ein
}

//------------- Daten Heizung schalten seriell einlesen ----------------
void dataEinlesen(void){				

		uint8_t i,a;
	
		a=4;//Startadresse Data	

	for(i = 0;i < c_max_byte;i += 4){
	
		wodata[i]  =einlesen(serData,a,1);		//4-10-16-22
		wodata[i+1]=einlesen(serData,a+1,2);	//5-11-17-23
		wodata[i+2]=einlesen(serData,a+3,2);	//7-13-19-25
		wodata[i+3]=einlesen(serData,a+5,1);	//9-15-21-27
		a+=6;
		}

		eeprom_write_block(wodata,eeFooByteArray1,sizeof(wodata));	// Block schreiben		
}


//-------------------- Daten Heizung schalten seriell ausgeben -------------------------------
void DataOutSer(void){

		uint8_t i;
	while ( ser.gesperrt ==true ) ;	// warten bis Datenleitung frei ist 
	
		for (i = 0;i < c_max_byte;i += 4){
		sprintf( send, "Data %2d= %1d:%2d:%2d:%1d", i+1,wodata[i],wodata[i+1],wodata[i+2],wodata[i+3] );
		uputsnl(send);	
		}	
}


//------------Aktuellen Status und Zeit anzeigen-----------------
void dagDisplay(void){

		char zeit[20];
		lcd1_clear();
		lcd2_clear();

		if(Status.t_heizung){lcd1_string("Heizung");}

		if(Status.t_zirkulation){set_cursor1(16,1);lcd1_string("Zirkulation");}

		if(Status.t_brenner){set_cursor1(8,1);lcd1_string("Brenner");}

		if(Status.t_stoerung){set_cursor1(8,2);lcd1_string("St"); 		//Strung ausgeben
							lcd1_data(0xEF);lcd1_string("rung");}									

		if(Status.t_wasser){set_cursor1(0,2);lcd1_string("Wasser");}

		if(Status.t_laden){set_cursor1(16,2);lcd1_string("Ladepumpe");}

		ser.timedisplay=true;

		set_cursor2(5,1);

		lcd2_string(tag_set[tag]);		//Tag anzeigen

		sprintf( zeit, "%2d:%2d:%2d", stunde,minute,sekunde  );
					
	
		lcd2_string(zeit);				//Stunde,minute,sekunde anzeigen

}


//------------ Schaltzeiten  anzeigen -------------------
void switchDisplay(uint8_t TC){

		char zeit[20];
		lcd2_clear();
		lcd1_clear();
		lcd2_clear();

		set_cursor1(0,2);lcd1_string("Data");
		set_cursor1(10,2);lcd1_string("Tag");
		set_cursor1(15,2);lcd1_string("Std/Min");
		set_cursor1(20,2);lcd1_string("Status");

		ser.timedisplay=false;

		if (TC ==255){TC = c_max_data;timecount=TC;}

		if (TC > c_max_data){TC = 0;timecount=TC;}


// wodata[0] = Tag  
// wodata[1] = Stunde
// wodata[2] = Minute
// wodata[3] = Status

		set_cursor2(1,1);
		lcd2_putint(TC+1);						// Datensatz ausgeben


		set_cursor2(5,1);

		lcd2_string(tag_set[wodata[TC*4]]);		//Tag ausgeben
		      uputs(tag_set[wodata[TC*4]]);	

		sprintf( zeit, " %2d:%2d  ", wodata[TC*4+1],wodata[TC*4+2]  );
		
		lcd2_string(zeit);						//Zeit ausgeben
		      uputs(zeit);	

		lcd2_string(stat_set[wodata[TC*4+3]]);	//Status ausgeben
		    uputsnl(stat_set[wodata[TC*4+3]]);
}



//--------  Relais rel1 und rel2 schalten -------------
void Relais_ausgeben(void){

REL_DDR =0xFF;							//PortA als Ausgang setzen

		rel_port= rel1;
		// rel steuerport als Ausgang
	 	rel_steuer &= ~(1<<output1);
	   	asm("nop");                 	// kurze Pause 
	  	rel_steuer |= (1<<output1);

		rel_port= rel2;
	 	rel_steuer &= ~(1<<output2);
	  	asm("nop");                   	// kurze Pause 
	  	rel_steuer |= (1<<output2);

		// rel Steuerport als Eingang
}

//-----------Schaltzeiten mit aktueller Zeit Vergleichen -------------------
void steuer_heizung(void){
	uint8_t i;

	for(i = 0; i < c_max_data ; i++){

	if(wodata[i*4] == 8) vergleich_Zeit(i*4);				// Zeitvergleich fr Woche
	if(wodata[i*4] == tag) vergleich_Zeit(i*4);				//Zeitvergleich fr aktuellen Tag

	}

}

//------------ Zeitvergleich mit Statusausgabe ---------------------------------
void vergleich_Zeit(uint8_t data){

if(wodata[data+1] == stunde) {
	if(wodata[data+2] == minute) {
		rel1&= ~( 1 << waelzen );
		Status.t_heizung=false; 							// Heizung Zirkulation Aus
		if(wodata[data+3] == 1){
			 rel1 |= ( 1 << waelzen );					// Heizung Zirkulation Ein
			 Status.t_heizung=true;
			 }
		Relais_ausgeben();
		}
		}
}


//------ Serielles Komando vom Netz einlesen -------------------------
uint8_t netz_ser(void){

uint8_t count,wert,res;
res=0;
count=0;
wert=128;
PORTC |=(1<<2);

delay_ms( zeit*3);
	while(count !=8){
		if (!( PINC & Netz_Sig ))res += wert;
		wert -= wert/2;
		count++;
		delay_ms( zeit*2 );
		}
//		res='H';
uputchar(res);
PORTC &=~(1<<2);
return res;
}
