// Ansteuerung eines HD44780 kompatiblen LCD im 4-Bit-Interfacemodus
// http://www.mikrocontroller.net/articles/AVR-GCC-Tutorial
//
void lcd1_data(unsigned char temp1);
void lcd1_string(char *data);
void lcd1_command(unsigned char temp1);
void lcd1_enable(void);
void lcd1_init(void);
void lcd1_home(void);
void lcd1_clear(void);
void set_cursor1(uint8_t x, uint8_t y);
void lcd1_putint(int value);
void lcd1_putword(char theword[]);

void lcd2_data(unsigned char temp1);
void lcd2_string(char *data);
void lcd2_command(unsigned char temp1);
void lcd2_enable(void);
void lcd2_init(void);
void lcd2_home(void);
void lcd2_clear(void);
void set_cursor2(uint8_t x, uint8_t y);
void lcd2_putint(int value);
void lcd2_putword(char theword[]);
 
// Hier die verwendete Taktfrequenz in Hz eintragen, wichtig!
 
/*
;-------------------------------------------------------------------
;       SONDERZEICHEN :   = 245     q = 241  ? = 63   < = 60       
;                         = 239      = 225  > = 62   ; = 59       
;                        P = 240      = 226  = = 61   : = 58       



*/

//-- LCD PORT ---------------------

#define LCD_STEUER_PORT     PORTC
#define	LCD_STEUER_DDR		DDRC
#define LCD_DATA_PORT		PORTA
#define LCD_DDR       		DDRA
#define LCD_RS        		6	//PA
#define LCD_EN1       		4	//PC
#define LCD_EN2       		3	//PC
 
// LCD Befehle
 
#define CLEAR_DISPLAY 	0x01
#define CURSOR_HOME   	0x02
#define COURSOR_OFF   	0x0C
#define COURSOR_ON 		0x0E



 
// Pinbelegung fr das LCD, an verwendete Pins anpassen
 


// DB4 bis DB7 des LCD sind mit PD0 bis PD3 des AVR verbunden 
