/************************************************************************/
/*                                                                      */
/*                      Heizungssteuerung           					*/
/*                                                                      */
/*              Author: Wolfgang Hopperdietzel                          */
/*                      				                                */
/*                                                                      */
/************************************************************************/
#ifndef _main_h_
#define _main_h_
#include <avr/io.h>
#include <avr/interrupt.h>
/* #include <avr/signal.h> */
#include <stdlib.h>
#include <stdio.h>
#include <avr/eeprom.h>


#define XTAL		12000000L

#define F_CPU 		12000000UL

#include <util/delay.h>


//------------ RS 232-----------------------------

/*
SerKomando

D	:		Adresse Schaltdaten Heizung wird an Endgert gesendet

R	:		Adresse Status zu schaltende Relais wird an Endgert gesendet
S	: 		Adresse Endgert wird Gerteadresse zugewiesen	
T	:		Adresse Aktuelle Zeit wird an Endgert gesendet
O 	: Keine Adresse Temperatur Auen und Status Heizung wird ausgegeben

*/

#define	BAUD	19200
#define bauddivider (uint)(1.0 * XTAL / BAUD / 16 - 0.5)


#define	adresse		55

#define	uartstart   0x05		//	Wert fr Startbit
#define uartstopp	0x06		//	Wert fr Stoppbit

#define c_max_empf  20  

#define c_max_data 	20
#define c_max_byte 	c_max_data*4	// Byteanzahl Data

char serData[200];



uint8_t wodata[c_max_byte];
uint8_t	empfang_count;

uint16_t zeit;
uint8_t sercount;



//------------ Global --------------------------

#define true 	1
#define false	0 
#define uchar unsigned char
#define uint unsigned int
#define bit uchar
#define idata
#define code

//--------- DS18B20---------------------------

uint8_t volatile	kanal;

#define	c_kanal_max	8
#define c_kanal_aktuell  5

uint16_t Sensor[8];

#define W1_PIN	PD5
#define W1_IN	PIND
#define W1_OUT	PORTD
#define W1_DDR	DDRD

/*
temperatur[0]	=	Auentemperatur
temperatur[1]	=	Kessel Heizung
temperatur[2]	=	Vorlauf Heizung
temperatur[3]	=	Rcklauf Heizung
temperatur[4]	=	Brauchwasser
temperatur[5]	=	
temperatur[6]	=	 
temperatur[7]	=	 
*/




//------------- Zeit --------------------------

uint8_t volatile sekunde,stunde,minute,tag;
uint8_t	timecount;

struct{

	unsigned empfang:1;	// ist 1 wenn eine Zeichenkette erfolgreich bertragen wurde
	unsigned gesperrt:1;// ist 1 wenn ein anderer Teilnehmer sendet
	unsigned data:1;	// ist 1 wenn ein Zeichen empfangen wurde 
	unsigned noData:1;
	unsigned remote:1;
	unsigned temp_start:1;
	unsigned secpuls:1;
	unsigned timedisplay:1;    
}volatile ser;


union
{
 unsigned char byte;
struct
{
  	unsigned t_heizung:1;
	unsigned t_zirkulation:1;
	unsigned t_brenner:1;
	unsigned t_stoerung:1;
	unsigned t_laden:1;
	unsigned t_wasser:1;
	unsigned t_zeitanzeige:1;  
};
}volatile Status;






//------------ Relais ----------------------------

uint8_t rel1,rel2;

#define	REL_DDR		DDRA
#define rel_port	PORTA
#define	rel_steuer	PORTB
#define output1		PB1
#define output2		PB2
#define Netz_in     5
#define Netz_Sig	32


//--Rel1 definition--
#define zirkulation		1
#define Brenner			2
#define mischer_plus	3
#define mischer_minus	4
#define waelzen			5
#define ladepumpe		6
#define	Heizung			7





//----------- EEPROM --------------------------

// EEMEM wird bei aktuellen Versionen der avr-lib in eeprom.h definiert
// hier: definiere falls noch nicht bekannt ("alte" avr-libc)
#ifndef EEPROM
// alle Textstellen EEMEM im Quellcode durch __attribute__ ... ersetzen
#define EEPROM  __attribute__ ((section (".eeprom")))
#endif



#include 	"1wire.h"
#include 	"delay.h"
#include 	"tempmeas.h"
#include 	"timebase.h"
#include 	"uart.h"
#include	"tastatur.h"
#include	"lcd_2.h"
#include	"anzeige.h"

#endif
