#include "main.h"

//------ initialisierung ----------------
void uartinit( void )
{
  UBRRL = bauddivider;			//set baud rate
  UBRRH = bauddivider >> 8;
  UCSRA = 0;				//no U2X, MPCM
  UCSRC = 1<<URSEL^1<<UCSZ1^1<<UCSZ0;	//8 Bit
  UCSRB = 1<<RXEN^1<<TXEN^1<<RXCIE   ;		//enable RX, TX	  ^1<<RXCIE
}

//--------- Zeihen senden ------------
void uputchar( char c )
{
  while( (UCSRA & 1<<UDRE) == 0 );
  UDR = c;
}

//--------- Zeihenkette senden ------------
void uputs( char *s )		
{
  while( *s )
    uputchar( *s++ );
}


//-------- Zeihenkette senden mit Zeilenumbruch ------
void uputsnl( char *s )	
{
  uputs( s );
  uputchar( 13 );
  uputchar( 10 );

}


//-------- Wert senden -------------
void uputint(int value){ 		
 char tmp[20]; 	
        itoa(value, tmp, 10);
   		uputs(tmp);
		}


//--------- Wert senden mit zeilenumbruch ----------
void uputintnl(int value){ 		
 char tmp[20]; 	
        itoa(value, tmp, 10);
   		uputs(tmp);
		uputchar( 13 );
  		uputchar( 10 );
}

//------- seriellen interrupt auswerten
ISR (USART_RXC_vect) {								// Zeichenkette empfangen


uint8_t read,max_data;								// Startzeichen = 0x05
													// Stoppzeichen = 0x0a
	read=UDR;

	ser.data=true; // Zeichenwurde empfangen wirt im TimerInterrupt  ausgewertet


	uputchar(read);
	max_data=c_max_empf;

	if(ser.noData==false)  //Empangene Daten auswerten
		{

		if(serData[0]=='D')max_data=(c_max_data*6+4); 	// 20*6= 120 zeichen +4 Zeichen Adresse lesen

		if(read== uartstart){
			empfang_count=0;			// Zeichenkette empfangen starten
			ser.gesperrt=true;
			}
 
		if(read!= uartstart && read!= uartstopp){
			serData[empfang_count]=read;
			empfang_count++;
			}

		if(read== uartstopp && empfang_count == max_data){
			serData[empfang_count]= '\0';					// Zeichenkette empfangen : x.empfang=true		
			ser.empfang=true;
				ser.gesperrt=false;
			}

		}
}


